'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _objectWithoutProperties = require('babel-runtime/helpers/object-without-properties')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactStaticContainer = require('react-static-container');

var _reactStaticContainer2 = _interopRequireDefault(_reactStaticContainer);

var _getParamsForRoute = require('./getParamsForRoute');

var _getParamsForRoute2 = _interopRequireDefault(_getParamsForRoute);

var _RootComponent = require('./RootComponent');

var _RootComponent2 = _interopRequireDefault(_RootComponent);

var _RouteAggregator = require('./RouteAggregator');

var _RouteAggregator2 = _interopRequireDefault(_RouteAggregator);

var Container = (function (_React$Component) {
  _inherits(Container, _React$Component);

  function Container() {
    _classCallCheck(this, Container);

    _React$Component.apply(this, arguments);
  }

  Container.prototype.render = function render() {
    var routeAggregator = this.context.routeAggregator;

    if (!routeAggregator) {
      return _react2['default'].createElement(_RootComponent2['default'], this.props);
    }

    var _props = this.props;
    var Component = _props.Component;

    var routerProps = _objectWithoutProperties(_props, ['Component']);

    var route = routerProps.route;
    var queries = route.queries;

    if (!queries) {
      return _react2['default'].createElement(Component, routerProps);
    }

    var params = _getParamsForRoute2['default'](routerProps);

    var _routeAggregator$getData = routeAggregator.getData(route, queries, params);

    var fragmentPointers = _routeAggregator$getData.fragmentPointers;
    var failure = _routeAggregator$getData.failure;

    var shouldUpdate = true;
    var element = undefined;

    // This is largely copied from RelayRootContainer#render.
    if (failure) {
      var renderFailure = route.renderFailure;

      if (renderFailure) {
        var error = failure[0];
        var retry = failure[1];

        element = renderFailure(error, retry);
      } else {
        element = null;
      }
    } else if (fragmentPointers) {
      var data = _extends({}, routerProps, params, fragmentPointers);

      var renderFetched = route.renderFetched;

      if (renderFetched) {
        element = renderFetched(data);
      } else {
        element = _react2['default'].createElement(Component, data);
      }
    } else {
      var renderLoading = route.renderLoading;

      if (renderLoading) {
        element = renderLoading();
      } else {
        element = undefined;
      }

      if (element === undefined) {
        element = null;
        shouldUpdate = false;
      }
    }

    return _react2['default'].createElement(
      _reactStaticContainer2['default'],
      { shouldUpdate: shouldUpdate },
      element
    );
  };

  _createClass(Container, null, [{
    key: 'displayName',
    value: 'ReactRouterRelay.Container',
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      Component: _react2['default'].PropTypes.func.isRequired
    },
    enumerable: true
  }, {
    key: 'contextTypes',
    value: {
      routeAggregator: _react2['default'].PropTypes.instanceOf(_RouteAggregator2['default'])
    },
    enumerable: true
  }]);

  return Container;
})(_react2['default'].Component);

exports['default'] = Container;
module.exports = exports['default'];