'use strict';

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _Object$assign = require('babel-runtime/core-js/object/assign')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

exports.__esModule = true;
exports['default'] = getParamsForRoute;

var _reactRouterLibGetRouteParams = require('react-router/lib/getRouteParams');

var _reactRouterLibGetRouteParams2 = _interopRequireDefault(_reactRouterLibGetRouteParams);

function getParamsForRoute(_ref2) {
  var route = _ref2.route;
  var routes = _ref2.routes;
  var params = _ref2.params;
  var location = _ref2.location;

  var paramsForRoute = {};

  // Extract route params for current route and all ancestors.
  for (var _iterator = routes, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _getIterator(_iterator);;) {
    var _ref;

    if (_isArray) {
      if (_i >= _iterator.length) break;
      _ref = _iterator[_i++];
    } else {
      _i = _iterator.next();
      if (_i.done) break;
      _ref = _i.value;
    }

    var ancestorRoute = _ref;

    _Object$assign(paramsForRoute, _reactRouterLibGetRouteParams2['default'](ancestorRoute, params));
    if (ancestorRoute === route) {
      break;
    }
  }

  // Extract specified routes from query.
  if (route.queryParams) {
    (function () {
      // Can't use destructuring default value here, because location.query is
      // null when no query string is present.
      var query = location.query || {};

      route.queryParams.forEach(function (queryParam) {
        var queryValue = query[queryParam];
        paramsForRoute[queryParam] = queryValue !== undefined ? queryValue : null;
      });
    })();
  }

  return paramsForRoute;
}

module.exports = exports['default'];